
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>nginx的请求接收流程（一） / iVAN</title>

    <meta name="description" content="nginx的请求接收流程（一） 今年我们组计划写一本nginx模块开发以及原理解析方面的书,整本书是以open book的形式在网上会定时的更新,网址为http://tengine.taobao.org/book/index.html.本书分析的nginx源码版本为1.2.0,环境为linux,事件处理模型为epoll,大部分分析流程都基于以上假设.我会负责其中一些章节的编写,所以打算在这里写一系列我负责章节内容相关的文章(主要包括nginx各phase模块的开发,nginx请求的处理流程等).本篇文章主要会介绍nginx中请">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">nginx的请求接收流程（一）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>今年我们组计划写一本nginx模块开发以及原理解析方面的书，整本书是以open book的形式在网上会定时的更新，网址为http://tengine.taobao.org/book/index.html。本书分析的nginx源码版本为1.2.0，环境为linux，事件处理模型为epoll，大部分分析流程都基于以上假设。我会负责其中一些章节的编写，所以打算在这里写一系列我负责章节内容相关的文章（主要包括nginx各phase模块的开发，nginx请求的处理流程等）。本篇文章主要会介绍nginx中请求的接收流程，包括请求头的解析和请求体的读取流程。</p>
<p> </p>
<p>首先介绍一下rfc2616中定义的http请求基本格式：</p>
<p> </p>
<p><strong>[cpp]</strong> <a href="http://blog.csdn.net/fengmo_q/article/details/7457901" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/fengmo_q/article/details/7457901" rel="external nofollow noreferrer">copy</a><br />
<br /> </p>
<ol>
<li>&lt;span style="font-size:18px;"&gt;Request = Request-Line   </li>
<li>      *(( general-header           </li>
<li>           | request-header            </li>
<li>           | entity-header ) CRLF)    </li>
<li>          CRLF  </li>
<li>          [ message-body ]   &lt;/span&gt;  </li>
</ol>
<p> </p>
<p> </p>
<p>第一行是请求行（request line），用来说明请求方法，要访问的资源以及所使用的HTTP版本：</p>
<p> </p>
<p><strong>[cpp]</strong> <a href="http://blog.csdn.net/fengmo_q/article/details/7457901" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/fengmo_q/article/details/7457901" rel="external nofollow noreferrer">copy</a><br />
<br /> </p>
<ol>
<li>&lt;span style="font-size:18px;"&gt;Request-Line   = Method SP Request-URI SP HTTP-Version CRLF&lt;/span&gt;  </li>
</ol>
<p> </p>
<p> </p>
<p>请求方法（Method）的定义如下，其中最常用的是GET，POST方法：</p>
<p> </p>
<p><strong>[cpp]</strong> <a href="http://blog.csdn.net/fengmo_q/article/details/7457901" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/fengmo_q/article/details/7457901" rel="external nofollow noreferrer">copy</a><br />
<br /> </p>
<ol>
<li>&lt;span style="font-size:18px;"&gt;Method = "OPTIONS"   </li>
<li>| "GET"   </li>
<li>| "HEAD"   </li>
<li>| "POST"   </li>
<li>| "PUT"   </li>
<li>| "DELETE"   </li>
<li>| "TRACE"   </li>
<li>| "CONNECT"   </li>
<li>| extension-method   </li>
<li>extension-method = token&lt;/span&gt;  </li>
</ol>
<p> </p>
<p> </p>
<p>要访问的资源由统一资源地位符URI(Uniform Resource Identifier)确定，它的一个比较通用的组成格式（rfc2396）如下：</p>
<p> </p>
<p><strong>[cpp]</strong> <a href="http://blog.csdn.net/fengmo_q/article/details/7457901" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/fengmo_q/article/details/7457901" rel="external nofollow noreferrer">copy</a><br />
<br /> </p>
<ol>
<li>&lt;span style="font-size:18px;"&gt;&lt;scheme&gt;://&lt;authority&gt;&lt;path&gt;?&lt;query&gt; &lt;/span&gt;  </li>
</ol>
<p> </p>
<p> </p>
<p>一般来说根据请求方法（Method）的不同，请求URI的格式会有所不同，通常只需写出path和query部分。</p>
<p>http版本(version)定义如下，现在用的一般为1.0和1.1版本：</p>
<p> </p>
<p><strong>[cpp]</strong> <a href="http://blog.csdn.net/fengmo_q/article/details/7457901" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/fengmo_q/article/details/7457901" rel="external nofollow noreferrer">copy</a><br />
<br /> </p>
<ol>
<li>HTTP/&lt;major&gt;.&lt;minor&gt;  </li>
</ol>
<p> </p>
<p> </p>
<p>请求行的下一行则是请求头，rfc2616中定义了3种不同类型的请求头，分别为general-header，request-header和entity-header，每种类型rfc中都定义了一些通用的头，其中entity-header类型可以包含自定义的头。</p>
<p>现在开始介绍nginx中请求头的解析，nginx的请求处理流程中，会涉及到2个非常重要的数据结构，ngx_connection_t和ngx_http_request_t，分别用来表示连接和请求，这2个数据结构在本书的前篇中已经做了比较详细的介绍，没有印象的读者可以翻回去复习一下，整个请求处理流程从头到尾，对应着这2个数据结构的分配，初始化，使用，重用和销毁。</p>
<p>nginx在初始化阶段，具体是在init process阶段的ngx_event_process_init函数中会为每一个监听套接字分配一个连接结构（ngx_connection_t），并将该连接结构的读事件成员（read）的事件处理函数设置为ngx_event_accept，并且如果没有使用accept互斥锁的话，在这个函数中会将该读事件挂载到nginx的事件处理模型上（poll或者epoll等），反之则会等到init process阶段结束，在工作进程的事件处理循环中，某个进程抢到了accept锁才能挂载该读事件。</p>
<p><strong>[cpp]</strong> <a href="http://blog.csdn.net/fengmo_q/article/details/7457901" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/fengmo_q/article/details/7457901" rel="external nofollow noreferrer">copy</a><br />
<br /> </p>
<ol>
<li>&lt;span style="font-size:18px;"&gt;static ngx_int_t  </li>
<li>ngx_event_process_init(ngx_cycle_t *cycle)  </li>
<li>{  </li>
<li>    ...  </li>
<li>  </li>
<li>  </li>
<li>    /* 初始化用来管理所有定时器的红黑树 */  </li>
<li>    if (ngx_event_timer_init(cycle-&gt;log) == NGX_ERROR) {  </li>
<li>        return NGX_ERROR;  </li>
<li>    }  </li>
<li>    /* 初始化事件模型 */  </li>
<li>    for (m = 0; ngx_modules[m]; m++) {  </li>
<li>        if (ngx_modules[m]-&gt;type != NGX_EVENT_MODULE) {  </li>
<li>            continue;  </li>
<li>        }  </li>
<li>  </li>
<li>  </li>
<li>        if (ngx_modules[m]-&gt;ctx_index != ecf-&gt;use) {  </li>
<li>            continue;  </li>
<li>        }  </li>
<li>  </li>
<li>  </li>
<li>        module = ngx_modules[m]-&gt;ctx;  </li>
<li>  </li>
<li>  </li>
<li>        if (module-&gt;actions.init(cycle, ngx_timer_resolution) != NGX_OK) {  </li>
<li>            /* fatal */  </li>
<li>            exit(2);  </li>
<li>        }  </li>
<li>  </li>
<li>  </li>
<li>        break;  </li>
<li>    }  </li>
<li>  </li>
<li>  </li>
<li>    ...  </li>
<li>  </li>
<li>  </li>
<li>    /* for each listening socket */  </li>
<li>    /* 为每个监听套接字分配一个连接结构 */  </li>
<li>    ls = cycle-&gt;listening.elts;  </li>
<li>    for (i = 0; i &lt; cycle-&gt;listening.nelts; i++) {  </li>
<li>  </li>
<li>  </li>
<li>        c = ngx_get_connection(ls[i].fd, cycle-&gt;log);  </li>
<li>  </li>
<li>  </li>
<li>        if (c == NULL) {  </li>
<li>            return NGX_ERROR;  </li>
<li>        }  </li>
<li>  </li>
<li>  </li>
<li>        c-&gt;log = &amp;ls[i].log;  </li>
<li>  </li>
<li>  </li>
<li>        c-&gt;listening = &amp;ls[i];  </li>
<li>        ls[i].connection = c;  </li>
<li>  </li>
<li>  </li>
<li>        rev = c-&gt;read;  </li>
<li>  </li>
<li>  </li>
<li>        rev-&gt;log = c-&gt;log;  </li>
<li>        /* 标识此读事件为新请求连接事件 */  </li>
<li>        rev-&gt;accept = 1;  </li>
<li>  </li>
<li>  </li>
<li>        ...  </li>
<li>  </li>
<li>  </li>
<li>#if (NGX_WIN32)  </li>
<li>  </li>
<li>  </li>
<li>        /* windows环境下不做分析，但原理类似 */  </li>
<li>  </li>
<li>  </li>
<li>#else  </li>
<li>        /* 将读事件结构的处理函数设置为ngx_event_accept */  </li>
<li>        rev-&gt;handler = ngx_event_accept;  </li>
<li>        /* 如果使用accept锁的话，要在后面抢到锁才能将监听句柄挂载上事件处理模型上 */  </li>
<li>        if (ngx_use_accept_mutex) {  </li>
<li>            continue;  </li>
<li>        }  </li>
<li>        /* 否则，将该监听句柄直接挂载上事件处理模型 */  </li>
<li>        if (ngx_event_flags &amp; NGX_USE_RTSIG_EVENT) {  </li>
<li>            if (ngx_add_conn(c) == NGX_ERROR) {  </li>
<li>                return NGX_ERROR;  </li>
<li>            }  </li>
<li>  </li>
<li>  </li>
<li>        } else {  </li>
<li>            if (ngx_add_event(rev, NGX_READ_EVENT, 0) == NGX_ERROR) {  </li>
<li>                return NGX_ERROR;  </li>
<li>            }  </li>
<li>        }  </li>
<li>  </li>
<li>  </li>
<li>#endif  </li>
<li>  </li>
<li>  </li>
<li>    }  </li>
<li>  </li>
<li>  </li>
<li>    return NGX_OK;  </li>
<li>}&lt;/span&gt;  </li>
</ol>
<p>当一个工作进程在某个时刻将监听事件挂载上事件处理模型之后，nginx就可以正式的接收并处理客户端过来的请求了。这时如果有一个用户在浏览器的地址栏内输入一个域名，并且域名解析服务器将该域名解析到一台由nginx监听的服务器上，nginx的事件处理模型接收到这个读事件之后，会速度交由之前注册好的事件处理函数ngx_event_accept来处理。</p>
<p>在ngx_event_accept函数中，nginx调用accept函数，从已连接队列得到一个连接以及对应的套接字，接着分配一个连接结构（ngx_connection_t），并将新得到的套接字保存在该连接结构中，这里还会做一些基本的连接初始化工作：<br />首先给该连接分配一个内存池，初始大小默认为256字节，可通过connection_pool_size指令设置；<br />分配日志结构，并保存在其中，以便后续的日志系统使用；<br />初始化连接相应的io收发函数，具体的io收发函数和使用的事件模型及操作系统相关；<br />分配一个套接口地址（sockaddr），并将accept得到的对端地址拷贝在其中，保存在sockaddr字段；<br />将本地套接口地址保存在local_sockaddr字段，因为这个值是从监听结构ngx_listening_t中可得，而监听结构中保存的只是配置文件中设置的监听地址，但是配置的监听地址可能是通配符*，即监听在所有的地址上，所以连接中保存的这个值最终可能还会变动，会被确定为真正的接收地址；<br />将连接的写事件设置为已就绪，即设置ready为1，nginx默认连接第一次为可写；<br />如果监听套接字设置了TCP_DEFER_ACCEPT属性，则表示该连接上已经有数据包过来，于是设置读事件为就绪；<br />将sockaddr字段保存的对端地址格式化为可读字符串，并保存在addr_text字段；<br />最后调用ngx_http_init_connection函数初始化该连接结构的其他部分。</p>
<p>ngx_http_init_connection函数最重要的工作是初始化读写事件的处理函数：将该连接结构的写事件的处理函数设置为ngx_http_empty_handler，这个事件处理函数不会做任何操作，实际上nginx默认连接第一次可写，不会挂载写事件，如果有数据需要发送，nginx会直接写到这个连接，只有在发生一次写不完的情况下，才会挂载写事件到事件模型上，并设置真正的写事件处理函数，这里后面的章节还会做详细介绍；读事件的处理函数设置为ngx_http_init_request，此时如果该连接上已经有数据过来（设置了deferred accept)，则会直接调用ngx_http_init_request函数来处理该请求，反之则设置一个定时器并在事件处理模型上挂载一个读事件，等待数据到来或者超时。当然这里不管是已经有数据到来，或者需要等待数据到来，又或者等待超时，最终都会进入读事件的处理函数-ngx_http_init_request。<br /> </p>
<p> </p>
<p>ngx_http_init_request函数主要工作即是初始化请求，由于它是一个事件处理函数，它只有唯一一个ngx_event_t *类型的参数，ngx_event_t 结构在nginx中表示一个事件，事件处理的上下文类似于一个中断处理的上下文，为了在这个上下文得到相关的信息，nginx中一般会将连接结构的引用保存在事件结构的data字段，请求结构的引用则保存在连接结构的data字段，这样在事件处理函数中可以方便的得到对应的连接结构和请求结构。进入函数内部看一下，首先判断该事件是否是超时事件，如果是的话直接关闭连接并返回；反之则是指之前accept的连接上有请求过来需要处理，ngx_http_init_request函数首先在连接的内存池中为该请求分配一个ngx_http_request_t结构，这个结构将用来保存该请求所有的信息。分配完之后，这个结构的引用会被包存在连接的hc成员的request字段，以便于在长连接或pipelined请求中复用该请求结构。在这个函数中，nginx根据该请求的接收端口和地址找到一个默认虚拟服务器配置（listen指令的default_server属性用来标识一个默认虚拟服务器，否则监听在相同端口和地址的多个虚拟服务器，其中第一个定义的则为默认），因为在nginx配置文件中可以设置多个监听在不同端口和地址的虚拟服务器（每个server块对应一个虚拟服务器），另外还根据域名（server_name指令可以配置该虚拟服务器对应的域名）来区分监听在相同端口和地址的虚拟服务器，每个虚拟服务器可以拥有不同的配置内容，而这些配置内容决定了nginx在接收到一个请求之后如何处理该请求。找到之后，相应的配置被保存在该请求对应的ngx_http_request_t结构中。注意这里根据端口和地址找到的默认配置只是临时使用一下，最终nginx会根据域名找到真正的虚拟服务器配置，随后的初始化工作还包括：</p>
<p>将连接的读事件的处理函数设置为ngx_http_process_request_line函数，这个函数用来解析请求行，将请求的read_event_handler设置为ngx_http_block_reading函数，这个函数实际上什么都不做（当然在事件模型设置为水平触发时，唯一做的事情就是将事件从事件模型监听列表中删除，防止该事件一直被触发），后面会说到这里为什么会将read_event_handler设置为此函数；<br />为这个请求分配一个缓冲区用来保存它的请求头，地址保存在header_in字段，默认大小为1024个字节，可以使用client_header_buffer_size指令修改，这里需要注意一下，nginx用来保存请求头的缓冲区是在该请求所在连接的内存池中分配，而且会将地址保存一份在连接的buffer字段中，这样做的目的也是为了给该连接的下一次请求重用这个缓冲区，另外如果客户端发过来的请求头大于1024个字节，nginx会重新分配更大的缓存区，默认用于大请求的头的缓冲区最大为8K，最多4个，这2个值可以用large_client_header_buffers指令设置，后面还会说到请求行和一个请求头都不能超过一个最大缓冲区的大小；<br />同样的nginx会为这个请求分配一个内存池，后续所有与该请求相关的内存分配一般都会使用该内存池，默认大小为4096个字节，可以使用request_pool_size指令修改；<br />为这个请求分配响应头链表，初始大小为20；<br />创建所有模块的上下文ctx指针数组，变量数据；<br />将该请求的main字段设置为它本身，表示这是一个主请求，nginx中对应的还有子请求概念，后面的章节会做详细的介绍；<br />将该请求的count字段设置为1，count字段表示请求的引用计数；<br />将当前时间保持在start_sec和start_msec字段，这个时间是该请求的起始时刻，将被用来计算一个请求的处理时间（request time），nginx使用的这个起始点和apache略有差别，nginx中请求的起始点是接收到客户端的第一个数据包开始，而apache则是接收到客户端的整个request line后开始算起；<br />初始化请求的其他字段，比如将uri_changes设置为11，表示最多可以将该请求的uri改写10次，subrequests被设置为201，表示一个请求最多可以发起200个子请求；<br />做完所有这些初始化工作之后，ngx_http_init_request函数会调用读事件的处理函数来真正的解析客户端发过来的数据，也就是会进入ngx_http_process_request_line函数中处理。</p>
<p>ngx_http_process_request_line函数的主要作用即是解析请求行，同样由于涉及到网络IO操作，即使是很短的一行请求行可能也不能被一次读完，所以在之前的ngx_http_init_request函数中，ngx_http_process_request_line函数被设置为读事件的处理函数，它也只拥有一个唯一的ngx_event_t *类型参数，并且在函数的开头，同样需要判断是否是超时事件，如果是的话，则关闭这个请求和连接；否则开始正常的解析流程。先调用ngx_http_read_request_header函数读取数据。</p>
<p>由于可能多次进入ngx_http_process_request_line函数，ngx_http_read_request_header函数首先检查请求的header_in指向的缓冲区内是否有数据，有的话直接返回；否则从连接读取数据并保存在请求的header_in指向的缓存区，而且只要缓冲区有空间的话，会一次尽可能多的读数据，读到多少返回多少；如果客户端暂时没有发任何数据过来，并返回NGX_AGAIN，返回之前会做2件事情：1，设置一个定时器，时长默认为60s，可以通过指令client_header_timeout设置，如果定时事件到达之前没有任何可读事件，nginx将会关闭此请求；2，调用ngx_handle_read_event函数处理一下读事件-如果该连接尚未在事件处理模型上挂载读事件，则将其挂载上；如果客户端提前关闭了连接或者读取数据发生了其他错误，则给客户端返回一个400错误（当然这里并不保证客户端能够接收到响应数据，因为客户端可能都已经关闭了连接），最后函数返回NGX_ERROR；</p>
<p>如果ngx_http_read_request_header函数正常的读取到了数据，ngx_http_process_request_line函数将调用ngx_http_parse_request_line函数来解析，这个函数根据http协议规范中对请求行的定义实现了一个有限状态机，经过这个状态机，nginx会记录请求行中的请求方法（Method），请求uri以及http协议版本在缓冲区中的起始位置，在解析过程中还会记录一些其他有用的信息，以便后面的处理过程中使用。如果解析请求行的过程中没有产生任何问题，该函数会返回NGX_OK；如果请求行不满足协议规范，该函数会立即终止解析过程，并返回相应错误号；如果缓冲区数据不够，该函数返回NGX_AGAIN。在整个解析http请求的状态机中始终遵循着两条重要的原则：减少内存拷贝和回溯。内存拷贝是一个相对比较昂贵的操作，大量的内存拷贝会带来较低的运行时效率。nginx在需要做内存拷贝的地方尽量只拷贝内存的起始和结束地址而不是内存本身，这样做的话仅仅只需要两个赋值操作而已，大大降低了开销，当然这样带来的影响是后续的操作不能修改内存本身，如果修改的话，会影响到所有引用到该内存区间的地方，所以必须很小心的管理，必要的时候需要拷贝一份。这里不得不提到nginx中最能体现这一思想的数据结构，ngx_buf_t，它用来表示nginx中的缓存，在很多情况下，只需要将一块内存的起始地址和结束地址分别保存在它的pos和last成员中，再将它的memory标志置1，即可表示一块不能修改的内存区间，在另外的需要一块能够修改的缓存的情形中，则必须分配一块所需大小的内存并保存其起始地址，再将ngx_bug_t的temprary标志置1，表示这是一块能够被修改的内存区域。</p>
<p>再回到ngx_http_process_request_line函数中，如果ngx_http_parse_request_line函数返回了错误，则直接给客户端返回400错误；<br />如果返回NGX_AGAIN，则需要判断一下是否是由于缓冲区空间不够，还是已读数据不够。如果是缓冲区大小不够了，nginx会调用ngx_http_alloc_large_header_buffer函数来分配另一块大缓冲区，如果大缓冲区还不够装下整个请求行，nginx则会返回414错误给客户端，否则分配了更大的缓冲区并拷贝之前的数据之后，继续调用ngx_http_read_request_header函数读取数据来进入请求行自动机处理，直到请求行解析结束；<br />如果返回了NGX_OK，则表示请求行被正确的解析出来了，这时先记录好请求行的起始地址以及长度，并将请求uri的path和参数部分保存在请求结构的uri字段，请求方法起始位置和长度保存在method_name字段，http版本起始位置和长度记录在http_protocol字段。还要从uri中解析出参数以及请求资源的拓展名，分别保存在args和exten字段。接下来将要解析请求头，我将在下一篇文章中接着介绍。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 12:57:16</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e7%bb%93%e6%9e%84/" title="数据结构">数据结构</a>, <a href="https://www.iamivan.net/tag/nginx/" title="nginx">nginx</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>nginx的请求接收流程（一）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8kxV9M.html" rel="bookmark">client发的请求接收返回信息时用send来接收，其余的由receive来接收，怎么改？求大神帮忙</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 client发的请求接收返回信息时用send来接收,其余的由receive来接收,怎么改?求大神帮忙 sever的请求都友client的receive来接收,client发的请求接收返回信息时用send来接收,怎么改下?求大神帮忙,我只会大概写了下代码,菜鸟急需用! package test; import java.io.BufferedReader; import java.io.InputStream; import java.io.InputStreamReader; impo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRDDydz.html" rel="bookmark">《深入剖析Nginx》一2&period;4 获得Nginx程序完整执行流程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.4 获得Nginx程序完整执行流程 深入剖析Nginx 利用strace命令能帮助我们获取到Nginx在运行过程中所发起的所有系统调用,但是不能看到Nginx内部各个函数的调用情况.利用gdb调试Nginx能让我们很清晰地获得Nginx每一步的执行流程,但是单步调试毕竟是非常麻烦的,有没有更为方便的方法一次性获得Nginx程序执行的整个流程呢?答案是肯定的,而且方法还非常多1.虽然相比直接使用某些强大工具(如System Tap2)而言,下面要介绍的方法比较笨,但它的确可行,而且从这个过程中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7ZZk5p.html" rel="bookmark">《深入剖析Nginx》&mdash;&mdash;2&period;4 获得Nginx程序完整执行流程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.4 获得Nginx程序完整执行流程 利用strace命令能帮助我们获取到Nginx在运行过程中所发起的所有系统调用,但是不能看到Nginx内部各个函数的调用情况.利用gdb调试Nginx能让我们很清晰地获得Nginx每一步的执行流程,但是单步调试毕竟是非常麻烦的,有没有更为方便的方法一次性获得Nginx程序执行的整个流程呢?答案是肯定的,而且方法还非常多1.虽然相比直接使用某些强大工具(如System Tap2)而言,下面要介绍的方法比较笨,但它的确可行,而且从这个过程中也许能学到一些额外的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNv92WM.html" rel="bookmark">jquery的ajax异步请求接收返回json数据实例&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				jquery的ajax异步请求接收返回json数据方法设置简单,一个是服务器处理程序是返回json数据,另一种就是ajax发送设置的datatype设置为jsonp格式数据或json格式都可以. 代码示例如下: 复制代码 代码如下: $('#send').click(function () {     $.ajax({         type : &quot;GET&quot;,         url : &quot;a.php&quot;,         dataType : &quot;json			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxEwoGp.html" rel="bookmark">ASP&period;Net 请求响应流程简述&lowbar;实用技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.浏览器请求页面的简单流程 当浏览器请求静态页面时,会发送请求给服务器软件,服务器软件直接去找对应的静态页面,并返回给浏览器. 当浏览器请求动态页面时,服务器软件收到请求,发现处理不了.aspx文件,就去映射表当中根据后缀名找对应的处理程序(aspnet_isapi.dll),这个处理程序实现了服务器软件提供的接口,即服务器软件通过接口调用了这个处理程序当中的方法.aspnet_isapi.dll会将请求转交给.Net Framework,由它处理动态页面,创建页面对象,生成相应报文,响应给浏			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLJrBkb.html" rel="bookmark">ssh实现客户端请求的流程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 从这三个框架的组建,接收的请求用到的持久化.流程中用到的框架的具体原理,说的越详细越好.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4RvXrM.html" rel="bookmark">nginx限制请求数和连接数来防御cc攻击</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				主要通过nginx的http_limit_conn和http_limit_req模块来防御cc攻击. ngx_http_limit_req_module可以限制单个IP每秒请求数 ngx_http_limit_conn_module可以限制单个IP的连接数 通过限制请求数和连接数能相对有效的防御CC攻击. 1.限制每秒请求数 ngx_http_limit_req_module模块指令通过漏桶原理来限制单位时间内的请求数,一旦单位时间内请求数超过限制,就会返回503错误,需要分别在http和ser			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5Y08ap.html" rel="bookmark">Zend framework处理一个http请求的流程分析&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  1, 首先是bootstrap过程,初始化程序里用到的资源 2, 创建一个Zend_Controller_Front实体,实现front controller模式,这个实体类会负责将http请求派遣到恰当的controller的action里. 3, Front controller会创建俩个对象来封装http请求和http回复,分别是Zend_Controller_Request_Http和Zend_Controller_Response_Http 4, Front controller会			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmYR1ap.html" rel="bookmark">jquery ajax异步请求 接收返回json数据</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				例子  代码如下 复制代码 $('#send').click(function () {     $.ajax({         type : &quot;GET&quot;,         url : &quot;a.php&quot;,         dataType : &quot;jsonp&quot;,         success : function (data) {             $.each(data.items, function (i, item) {       			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Xpm7Q3b.html" rel="bookmark" class="title">PPT动画教程：设置超链接跳转</a>
					<div>
						今天我们用动画的形式介绍在Powerpoint演示文稿中设置超级链接的方法和技巧. 我们在Powerpoint演示文稿的放映过程中,希望从某张幻灯片中快速切换到另外一张不连续的幻灯片中,可以通过&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boPZ6M.html" rel="bookmark" class="title">存取程序状态的几种方法&mdash;&mdash;Java I&sol;O应用杂谈</a>
					<div>
						程序 jungleford如是说     已经有一个多月没有搭理blog了,原因很多,譬如实验室的项目正在收工,巨忙:譬如找工作及其相关的事情:而且二月份大部分时间是陪老爹老妈,家里拨号的速度可想而知 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boeyXp.html" rel="bookmark" class="title">创建按钮（Buttons）和导航条（Navigation Bars）（上）</a>
					<div>
						按钮|创建 创建按钮(Buttons)和导航条(Navigation Bars)(上) 按钮是网页中应用极多的元素,众多的按钮就形成了导航条,导航条的作用就是要让浏览者清楚知道当前所处的位置,并且通过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5m5Dp.html" rel="bookmark" class="title">用&excl;important解决IE和Mozilla的布局差别</a>
					<div>
						解决 作者:阿捷 2004-7-24 14:56:36在设计&lt;网页设计师&gt;页面的时候,有一个问题一直困扰着我,主菜单在IE和其他(Mozilla.Opera等)浏览器里显示的效果偏差2px ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMq3WYz.html" rel="bookmark" class="title">整理3款网页用户行为跟踪分析工具</a>
					<div>
						初看下这些工具与网页流量统计很像,实际上作为网页用户行为跟踪分析工具来看,功能上不仅仅是简单的统计流量,而是涉及到用户访问网页的方方面面,比如用户的鼠标移动,键盘输入,点击行为等等.几乎可以将用户在网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKRy4p.html" rel="bookmark" class="title">怎么让CSS边框发光</a>
					<div>
						我们在进行网页设计的时候经常会将某些边框样式进行特殊处理以突显效果.今天小编就来讲解如何实现让CSS边框发光的高亮效果. 下图就是让CSS边框发光的高亮效果图 在输入框周围出现了亮光,或者说阴影造成边 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MArllKp.html" rel="bookmark" class="title">Win8应用闪退和无法访问指定设备的解决方法</a>
					<div>
						  解决应用闪退 1.使用快捷键win键+r键,打开运行窗口,输入&quot;cmd&quot;,点击确认. 2.输入&quot;net user administrator /active:no&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBvZDz.html" rel="bookmark" class="title">win7系统怎么进入DOS窗口？</a>
					<div>
						  方法一: 1.点击&quot;开始--搜索&quot;在搜索框中输入&quot;cmd&quot;命令后按回车; 2.在搜索结果中双击打开CMD即可. PS:如果用户经过优化后,不支持搜索功能的话 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3vLEz.html" rel="bookmark" class="title">AsyncTask源码分析</a>
					<div>
						关于AsyncTask的用法可以参看前面一篇博客&lt;AsyncTask实现断点续传&gt;,本文只解析AsyncTask的源代码. AsyncTask.execute方法: public fina ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRD7dkz.html" rel="bookmark" class="title">一个游戏引擎所应具有的元素</a>
					<div>
						原文:http://www.flipcode.com/archives/Elements_Of_A_Game_Engine.shtmlIntroduction (简介) 现在我们来说说你将如何写出一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZWRWz.html" rel="bookmark" class="title">多个装饰器-Python 装饰器的疑问？</a>
					<div>
						问题描述 Python 装饰器的疑问? 在学装饰器的时候看到这篇文章,[http://blog.csdn.net/mdl13412/article/details/22608283浅谈python闭包 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rqa0z.html" rel="bookmark" class="title">win7系统-电脑休眠后无法连接无线网</a>
					<div>
						问题描述 电脑休眠后无法连接无线网 电脑休眠 之后再打开时 电脑显示未连接 连接不可用 就无法连接网络 重启就好了 请问这是怎么回事 别说电源的那个 我已经试过了 请高手为我解决一下 谢谢 解决方案  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7ALkM.html" rel="bookmark" class="title">spring-Hibernate 二级缓存问题</a>
					<div>
						问题描述 Hibernate 二级缓存问题 框架是spring+hibernate,配置了二级缓存: 第一种方法二级缓存生效:直接调用session. 第二种方法二级缓存无效:使用hibernateT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmDwRM.html" rel="bookmark" class="title">海伦哲股权转让&OpenCurlyDoubleQuote;迷雾&rdquo;</a>
					<div>
						海伦哲股权转让&quot;迷雾&quot; 公司原第二大股东中矿科光入股20个月后&quot;零&quot;溢价.以债务抵股权形式退出:公司第三大股东深圳市众易实业有限公司上市前废除对赌协议 ■本周关 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjw9J0M.html" rel="bookmark" class="title">完善三个小细节 助力打造软件站最佳用户体验</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 随着信息技术时代的推进和发展,现在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAEB6nM.html" rel="bookmark" class="title">java-eclipse可以运行的程序在Dos窗口下出现好多不明的错误</a>
					<div>
						问题描述 eclipse可以运行的程序在Dos窗口下出现好多不明的错误 源代码如下 package ch1; //import java.io.*; public class TestEx{ publ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3J6B3z.html" rel="bookmark" class="title">江苏三友将召开致歉说明会</a>
					<div>
						涉嫌欺诈上市的江苏三友将于7月2日召开致歉说明会. 日前遭深交所公开谴责的江苏三友今日公告,公司及相关当事人就因控股股东股权发生变更而未及时履行信息披露义务受到深圳证券交易所处分事项向广大投资者公开致 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqv27p.html" rel="bookmark" class="title">惠普前CEO性骚扰案和解</a>
					<div>
						原告已经同意撤诉 马克·赫德将支付一定资金马克·赫德费舍尔 据外媒今晨报道,因性丑闻刚刚辞职的惠普首席执行官马克·赫德,已经与控诉被其性骚扰的临时工达成了法律和解,而女临时工同意撤销对惠普的起诉. 公 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWw78z.html" rel="bookmark" class="title">百度推出&OpenCurlyDoubleQuote;百发100&rdquo;指数</a>
					<div>
						DoNews 7月8日消息 8日,百度金融中心联合中证指数公司.广发基金发布中证百度百发策略100指数(以下简称&quot;百发100&quot;指数).据介绍,该产品基于大数据挖掘技术开发,首次将互 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlxg8p.html" rel="bookmark" class="title">Android-App增量更新的使用姿势&lowbar;Android</a>
					<div>
						简述 增量更新,根据字面理解,就是下载增加的那部分来达到更新的目的,实际就是这个意思. 原理 用一个旧的Apk安装与一个新的Apk安装包使用 bsdiff工具 ,执行命令生成一个差异文件,此差异文件就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba6AQNM.html" rel="bookmark" class="title">如何提高网站的广告收入</a>
					<div>
						     网站实用 网站实用主要体现在以下几点: 1.尽量符合用户习惯的设计,网站功能是适用; 2.网站层次合理,该突出时就突出,建立清楚的导航层次; 3.网站设有客服联系方式,当访客有所需,又不知怎 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8NKR9b.html" rel="bookmark" class="title">厉以宁：可适当增加黄金储备</a>
					<div>
						全国政协经济委员会副主任.民盟中央原名誉副主席厉以宁3月8日建议,我国可以适当增加黄金储备,特别是在黄金价格稍有下跌的时抓紧时间以外汇购入黄金.增加黄金储备有利于保证外汇储备的安全. 厉以宁是在全国政 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL5vk5z.html" rel="bookmark" class="title">巨人游戏分成遭质疑：站长不具备运营资质</a>
					<div>
						12月30日,近期巨人网络宣布旗下的&lt;体育帝国&gt;将联合站长运营,一起分享收益.针对这种模式,业内人士指出,联合站长运营立意虽好,但前途并不平坦. 一位从事网游行业的人士向TechWeb表示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6GxxNp.html" rel="bookmark" class="title">maven-Maven 项目打包上传服务器的时候出现问题 急急急！</a>
					<div>
						问题描述 Maven 项目打包上传服务器的时候出现问题 急急急! 用下面的命令传到服务器的时候出现了下面的错误,求大神指导 clean package deploy ...... [INFO] --- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgPWY5p.html" rel="bookmark" class="title">陌陌上线春节一起走功能 返乡路不再孤单</a>
					<div>
						近日,移动社交应用陌陌上线了&quot;春节一起走&quot;功能.这是陌陌专门为同乡打造的春节交流平台,基于陌陌独特的地理位置属性,可以方便用户结识同期返乡过年的同乡.而今年,用户只需要填写出发地. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk7vKop.html" rel="bookmark" class="title">isBIM签约8Manage 信息化管理提升企业效益</a>
					<div>
						近日,北京互联立方技术服务有限公司成功与8Manage签约,将上线8Manage客户关系管理与项目管理系统,实现项目计划.审批.人力资源以及绩效考核等商务与项目的一体化管理,提升企业的信息化管理效益. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boqEWvp.html" rel="bookmark" class="title">继北京奥运会，刘翔在伦敦奥运会上再次因伤退赛</a>
					<div>
						网视舆情 和上一回一样,网上出现大量质疑的声音,诸如刘翔收到金牌令被迫带伤参赛,其背号&quot;1356&quot;系领导安排,以及被广告商绑架等成为网络热门话题.网友&quot;无需惊讶&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Y0xBp.html" rel="bookmark" class="title">腾讯 无敌 的模式？</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 QQ是中国网民再熟悉不过的东西了,一打开电脑就挂Q已经成为我们习以为常的举动,甚至到了不需要经过大脑思考的程度.在中国上网,有人向你要QQ号,如果你说: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPWGn0M.html" rel="bookmark" class="title">马云携阿里17位创始人及合伙人捐赠浙大一院5&period;6亿，杭州渐成中国硅谷</a>
					<div>
						马云等人和机构此次联手大手笔捐赠浙大一院,开创了国内社会捐助公共医疗机构的先河. 6月9日,浙江大学在杭州对外宣布,浙江马云公益基金会.阿里巴巴17位创始人及合伙人.阿里巴巴(中国)有限公司.向浙江大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boqnjjp.html" rel="bookmark" class="title">Memcached真的过时了吗？</a>
					<div>
						这两年Redis火得可以,Redis也常常被当作Memcached的挑战者被提到桌面上来.关于Redis与Memcached的比较更是比比皆是.然而,Redis真的在功能.性能以及内存使用效率上都超越 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.036 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
